/**************************************************************************
 *
 * stack.cpp - Example program of stack. See Class Reference Section
 *
 * $Id: stack.cpp,v 1.13 1996/09/03 22:30:14 smithey Exp $
 *
 ***************************************************************************
 *    
 *  Copyright 2000 Compaq Computer Corporation
 *
 *  COMPAQ Registered in U.S. Patent and Trademark Office.
 *
 *  Confidential computer software. Valid license from Compaq required for
 *  possession, use or copying. Consistent with FAR 12.211 and 12.212,
 *  Commercial Computer Software, Computer Software Documentation, and
 *  Technical Data for Commercial Items are licensed to the U.S. Government
 *  under vendor's standard commercial license.
 *
 ***************************************************************************
 *
 * (c) Copyright 1994-1996 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 **************************************************************************/
 #ifndef _RWSTD_HEADER_REQUIRES_HPP
 #include <stack>
 #include <vector>
 #include <deque>
 #include <string>
 #else
 #include <stack.hpp>
 #include <vector.hpp>
 #include <deque.hpp>
 #include <string.hpp>
 #endif
 
 #ifdef __USE_STD_IOSTREAM
 #include <iostream>
 #else
 #include <iostream.h>
 #endif     

 int main ()
 {
#ifndef _RWSTD_NO_NAMESPACE
  using namespace std;
#endif

   //
   // Make a stack using a vector container.
   //
   stack<int,vector<int,allocator<int> > > s;
   //
   // Push a couple of values on the stack.
   //
   s.push(1);
   s.push(2);
   cout << s.top() << endl;
   //
   // Now pop them off.
   //
   s.pop();
   cout << s.top() << endl;
   s.pop();
   //
   // Make a stack of strings using a deque.
   //
   stack<string,deque<string,allocator<string> > > ss;
   //
   // Push a bunch of strings on then pop them off.
   //
   int i;
   for (i = 0; i < 10; i++)
   {
     ss.push(string(i+1,'a'));
     cout << ss.top() << endl;
   }
   for (i = 0; i < 10; i++)
   {
     cout << ss.top() << endl;
     ss.pop();
   }

   return 0;
 }
