#ifndef		__COMPLEX_ERROR_HXX
#define		__COMPLEX_ERROR_HXX

//
//    
//  Copyright 2000 Compaq Computer Corporation
//
//  COMPAQ Registered in U.S. Patent and Trademark Office.
//
//  Confidential computer software. Valid license from Compaq required for
//  possession, use or copying. Consistent with FAR 12.211 and 12.212,
//  Commercial Computer Software, Computer Software Documentation, and
//  Technical Data for Commercial Items are licensed to the U.S. Government
//  under vendor's standard commercial license.
//
//

//++
//  FACILITY:	DEC C++ Class Library
//
//  SUBSYSTEM:	Complex arithmetic
//
//  MODULE:	complex_error
//
//  INFORMATION HIDDEN:
//
//	External declaration of complex_error and set_complex_error.
//
//  MODULE DESCRIPTION:
//
//	This module contains the public declarations for the default error
//	handling function for the complex arithmetic package and how to change
//	the error handling function.
//
//--



//
//
//  INCLUDE FILES
//
//

#include <cxxl.hxx>

extern "C"
{
#include <stddef.h>
}

#ifdef __PRAGMA_ENVIRONMENT
#   pragma __environment save
#   pragma __environment header_defaults
#else
#   if defined(__VMS) && defined(__DECCXX)
#      pragma __extern_model __save
#      pragma __extern_prefix __save
#      pragma __member_alignment __save
#   endif
#endif

//
//
//  LINKAGE
//
//

#if defined(__VMS) && defined(__DECCXX)
#   pragma __extern_model __relaxed_refdef
#   pragma __extern_prefix __CXXL_PLAIN_FUNC_LINKAGE
#   if defined __VAX
#       pragma __nomember_alignment
#   else
#       pragma __member_alignment
#   endif
#endif

//
//
//  TYPE DEFINITIONS
//
//

// pointer to a complex error handling function
typedef int (*cxxl_p_complex_error_t)(c_exception &error_information);



//
//
//  EXTERNAL FUNCTIONS
//
//

extern int complex_error(c_exception &);
extern cxxl_p_complex_error_t set_complex_error(cxxl_p_complex_error_t);


#ifdef __PRAGMA_ENVIRONMENT
#   pragma __environment restore
#else
#   if defined(__VMS) && defined(__DECCXX)
#      pragma __extern_model  __restore
#      pragma __extern_prefix __restore
#      pragma __member_alignment __restore
#   endif
#endif

#endif
// End of complex_error.hxx
