#ifndef	__CXX_EXCEPTION_H
#define	__CXX_EXCEPTION_H
/*
**    
**  Copyright 2000 Compaq Computer Corporation
**
**  COMPAQ Registered in U.S. Patent and Trademark Office.
**
**  Confidential computer software. Valid license from Compaq required for
**  possession, use or copying. Consistent with FAR 12.211 and 12.212,
**  Commercial Computer Software, Computer Software Documentation, and
**  Technical Data for Commercial Items are licensed to the U.S. Government
**  under vendor's standard commercial license.
**
*/

#include <exception>

#ifdef __PRAGMA_ENVIRONMENT
#   pragma __environment save
#   pragma __environment header_defaults
#endif

#if defined(__VMS)

/* Certain OpenVMS conditions (as described in the DEC C Run-TIme Library
// Reference Manual for OpenVMS Systems) normally result in the delivery
// of signals.  You can call function cxxl$set_condition to change the
// behavior so that these VMS conditions are treated as exceptions
// by putting the following call in your program:
//
//    cxxl$set_condition (cxx_exception);
//
// Note that you can catch such exceptions using catch(...) or
// catch(struct chf$signal_array *).  Type chf$signal_array is defined in
// the system header file chfdef.h.
//
// To revert back to the default signal behavior, you can make the following
// call:
//
//    cxxl$set_condition (unix_signal);
//
// Function cxxl$set_condition returns the previous setting.
//
// This function affects all threads in a process.
*/
enum condition_behavior { unix_signal=0, cxx_exception=1 };

#ifdef __cplusplus
extern "C" condition_behavior
    cxxl$set_condition (condition_behavior signal_or_exc);
#endif

#else

// Entry point for determining information about a propagated
// exception within a catch(...) clause.
#if !defined(__linux)
#include <excpt.h>
system_exrec_type *__cxx_exception_info();
#endif

#endif //VMS

#ifdef __PRAGMA_ENVIRONMENT
#   pragma __environment restore
#endif

#endif		// End of cxx_exception.h
