#ifndef __CXXL_MUTEX_HXX
#define __CXXL_MUTEX_HXX

/***************************************************************************
 *    
 *  Copyright 2000 Compaq Computer Corporation
 *
 *  COMPAQ Registered in U.S. Patent and Trademark Office.
 *
 *  Confidential computer software. Valid license from Compaq required for
 *  possession, use or copying. Consistent with FAR 12.211 and 12.212,
 *  Commercial Computer Software, Computer Software Documentation, and
 *  Technical Data for Commercial Items are licensed to the U.S. Government
 *  under vendor's standard commercial license.
 *
 ****************************************************************************/

//++
//  FACILITY:	DEC C++ Class Library
//
//  SUBSYSTEM:	The Mutex package.
//
//  MODULE:	Include file for the Mutex subpackage.
//
//  MODULE DESCRIPTION:
//
//
//  DESIGN ISSUES:
//
//--

//++
//  INCLUDE FILES
//--

#include <cxxl.hxx>

#ifdef __PRAGMA_ENVIRONMENT
#   pragma __environment save
#   pragma __environment header_defaults
#else
#   if defined(__VMS) && defined(__DECCXX)
#      pragma __extern_model __save
#      pragma __extern_prefix __save
#      pragma __member_alignment __save
#   endif
#endif

class InternalMutex;

//
// Publicly visible Mutex class.  Make sure no inlining is done.
//
class Mutex {

  public:

#if defined(__VMS) && defined(__DECCXX)
#   pragma __extern_prefix __CXXL_PLAIN_FUNC_LINKAGE
#endif
     Mutex();
     ~Mutex();
     void lock();
     void unlock();

     // Return 1 if the mutex got locked, 0 otherwise.

     int tryLock();

  private:
     InternalMutex *ptr;

     // Disallow assignment and copy constructors.
     Mutex & operator=(const Mutex & rhs);
     Mutex(const Mutex &);
};

#ifdef __PRAGMA_ENVIRONMENT
#   pragma __environment restore
#else
#   if defined(__VMS) && defined(__DECCXX)
#      pragma __extern_model  __restore
#      pragma __extern_prefix __restore
#      pragma __member_alignment __restore
#   endif
#endif

#endif /* __CXXL_MUTEX_HXX */
