/*
 * *****************************************************************
 * *                                                               *
 * *    Copyright (c) Compaq Computer Corporation, 1999            *
 * *                                                               *
 * *   All Rights Reserved.  Unpublished rights  reserved  under   *
 * *   the copyright laws of the United States.                    *
 * *                                                               *
 * *   The software contained on this media  is  proprietary  to   *
 * *   and  embodies  the  confidential  technology  of  Compaq    *
 * *   Computer Corporation.  Possession, use,  duplication  or    *
 * *   dissemination of the software and media is authorized only  *
 * *   pursuant to a valid written license from Compaq Computer    *
 * *   Corporation.                                                *
 * *                                                               *
 * *   RESTRICTED RIGHTS LEGEND   Use, duplication, or disclosure  *
 * *   by the U.S. Government is subject to restrictions  as  set  *
 * *   forth in Subparagraph (c)(1)(ii)  of  DFARS  252.227-7013,  *
 * *   or  in  FAR 52.227-19, as applicable.                       *
 * *                                                               *
 * *****************************************************************
 */
/*
 * Four possible situations:
 * 	- We are being included by {var,std}args.h (or anyone) before stdio.h.
 * 	  define real type.
 *
 * 	- We are being included by stdio.h before {var,std}args.h.
 * 	  define hidden type for prototypes in stdio, don't pollute namespace.
 *
 * 	- We are being included by {var,std}args.h after stdio.h.
 * 	  define real type to match hidden type.  no longer use hidden type.
 *
 * 	- We are being included again after defining the real va_list.
 * 	  do nothing.
 *
 */

#if	defined(_REAL_VA_LIST) && !defined(_VA_LIST)
#define _VA_LIST
typedef struct {
	char	**_a0;		/* pointer to first homed integer arg */
	int	_offset;		/* byte offset of next param */
} va_list;

#elif	!defined(_REAL_VA_LIST) && !defined(_VA_LIST)
#define _VA_LIST
typedef struct {
	char	**_a0;		/* pointer to first homed integer arg */
	int	_offset;		/* byte offset of next param */
} __va_list;


#define _HIDDEN_VA_LIST

#elif	defined(_HIDDEN_VA_LIST)
typedef __va_list va_list;

#undef _HIDDEN_VA_LIST

#endif

#ifndef __gnuc_va_list
#define __gnuc_va_list va_list
#endif
